;readline routine

readline: ;r16 max length; y:pointer to string
      push r16
      push r17
      push r18
      push yl
      push yh
      mov r18,r16
      LDI r17,1 ;length 1 for 0 character
   readline_loop:
      CP r18,r17
      BREQ readline_end
      call serial_input
      call serial_output
      CPI r16,13
      BREQ readline_end
      CPI r16,10
      BREQ readline_end
      CPI r16,8
      BREQ readline_backspace
      ST Y+,r16
      inc r17
      rjmp readline_loop
   readline_backspace:
      SUBI Yl,1
      SBCI Yh,0
      dec r17      
   readline_end:      
      LDI r16,0
      ST Y+,r16
      pop yh
      pop yl
      pop r18
      pop r17
      pop r16

    ret
  