

.cseg

syscall_table:
.dw 0
.dw syscall_serial_output ; 1=output byte 
.dw syscall_serial_input  ; 2=input byte
.dw syscall_malloc	  ; 3=malloc
.dw syscall_free	  ; 4=free
.dw syscall_findfile	  ; 5=findfile

syscall:
    PUSH r21
    push Zl
    push zh
    LDI zl, low(syscall_table*2)
    LDI zh,high(syscall_table*2)
    LDI r21,0
    ADD zl,r20
    ADI zh,r21
    ADD zl,r20
    ADI zh,r21
    IJMP Z;???
  syscall_back:
    pop zh
    pop zl
    POP r21
  ret
	
	
syscall_serial_output:
    call serial_output
    rjmp syscall_back

syscall_serial_input:
    call serial_input
    LDI r17,0
    rjmp syscall_back    	
    
syscall_malloc:
    push yl
    push yh
    call heap_malloc 
    pop yh
    pop yl  
    rjmp syscall_back
    
syscall_free:
    call heap_free
    rjmp syscall_back

syscall_findfile:
    rjmp syscall_back
            