.org 0
rjmp start
.nolist
.include "controllers/m32def.inc"
.list
.org $20
start:
;    LDI r16,low(RAMEND)
;    OUT SPL,r16
;    LDI r16,high(RAMEND)
;    OUT SPH,r16
    
    LDI r16,$ff
    OUT DDRD,r16
;    LDI r16,0
;  looppp:
;    rjmp looppp
    

    LDI r17,32
   test_loop:
    LDI r16,'U'
    call serial_output
    dec r17
    CPI r17,0
    BRNE test_loop    


    call heap_init

    call dump_memory
    
    LDI r16, low(100)
    LDI r17,high(100)
    call heap_malloc
    
    movw r17:r16,yh:yl
    movw r21:r20,yh:yl
    call serial_output_16bit
    
    call dump_memory
        
    
    LDI r16, low(300)
    LDI r17,high(300)
    call heap_malloc
    
    movw r17:r16,zh:zl
    call serial_output_16bit
    
    call dump_memory
    
    movw yh:yl,r21:r20
    call heap_free
    
    call dump_memory
    
    LDI r16, low(50)
    LDI r17,high(50)
    call heap_malloc
    
    movw r17:r16,zh:zl
    call serial_output_16bit
    
    call dump_memory

    ende: 
        inc r16
    OUT PortD,r16

    rjmp ende


ramstartstring: 
.db "Heap-First-Free: ",0
ramendstring: 
.db "End of RAM listing",0,0

dump_memory:
    LDI Zl, low(ramstartstring*2)
    LDI Zh,high(ramstartstring*2)
    call serial_output_string_pm
    LDI r16,heap_first_free
    LDI r17,heap_first_free+1
    call serial_output_16bit
    call serial_output_crlf
    LDI xl, low(heap_start);
    LDI xh,high(heap_start);
    
  dump_memory_loop:    
    
    LD r18,X+
    LD r19,X+
    movW r17:r16,r19:r18
    call serial_output_16bit
    
    LDI r16,'-'
    call serial_output
    
    LD r18,X+
    LD r19,X+
    movW r17:r16,r19:r18
    call serial_output_16bit
    
    LDI r16, ' '
    call serial_output
    
    movw xh:xl,r19:r18
    
    CPI r18,0
    CPC r18,r19
    BRNE dump_memory_loop
    
    LDI Zl, low(ramendstring*2)
    LDI zh,high(ramendstring*2)
    call serial_output_string_pm
    call serial_output_crlf
    
  ret


.include "heap/heap.inc"
.include "serial/serial.inc"
.include "random/random.inc"
.include "filesystem/filesystem.inc"

