;filesystem

;entry
; 2 previous pointer (words)
; 2 next pointer (words)
; 2 size of content in bytes 0=> empty block
;14 filename (last 3 bytes type)
; file content 


filesystem_findfile:
    push r2
    push r3
    push r6
    push r7
    push r15
    push r16
    push r17
    push r18
    push r19
    push xl
    push xh
    push yl
    push yh
    
    LDI r18, low(filesystem_start*2);
    LDI r19,high(filesystem_start*2);
    
    
    movw r7:r6,Yh:yl ;store pointer file information block
    
  filesystem_nextfile:    
    movw zh:zl,r19:r18 ;move to next block
    
    movw r3:r2,zh:zl ;store pointer 
    
    CPI r3,0
    CPC r2,r3
    BREQ filesystem_finished ;error, last entry return 0
    
    ;get "byte" pointer
    LSL zl
    ROL zh
    ADIW Zh:Zl,2 ;next pointer
    ;store next pointer
    LPM r18,Z+ 
    LPM r19,Z+
    ADIW Zh:Zl,2 ;to filename
    movw Yh:Yl,r7:r6 ;Y points to filename
    movw Xh:Xl,r7:r6
    ADIW Xh:Xl,14    ;X points to mask
    LDI r15,14 ;counter
   compareloop_fsf:
    LPM r16,Z+ ;flash-filename
    LD	r17,X+ ;mask in ram
    AND r16,r17 ;AND it to apply mask
    LD r17,Y+ ;filename in ram
    CP r17,r16
    BRNE filesystem_nextfile
    DEC r15
    BRNZ compareloop_fsf
    
  filesystem_finished    
    movw Zh:Zl,r3:r2
    
    
    pop yh
    pop yl
    pop xh
    pop xl
    pop r19
    pop r19
    pop r17
    pop r16
    pop r15
    pop r7
    pop r6
    pop r3
    pop r2
    
  ret



.cseg
filesystem_start:
.dw 0 ;previous pointer
.dw filesystem_next ;next pointer
.db (filesystem_next-pc)*2 ;size in bytes
;    12345678901234
.db "testtextdattxt" ;testtextdat.txt
.db "This is a testtext file!\n"
.db "It has multiple lines of text.\n"
filesystem_next: ;currently last file.
.dw filesystem_start
.dw 0
.dw 0
