;string handling functions

strcmp_pm_ram: ;Compares strings y:pointer to RAM (zero terminated)
               ; z: pointer to ROM
	       ;r16 result
   push r17
   push r18
   push yl
   push yh
   push zl
   push zh	      
    
 strcmp_pm_loop:
   LPM r17,Z+
   LD r18,Y+
   CPI r18,0
   BREQ strcmp_pm_ram_equal
   CP r17,r18
   BREQ strcmp_pm_loop
   BRLT strcmp_pm_ram_less
   BRGE strcmp_pm_ram_more
     
 
 strcmp_pm_ram_less:
   LDI r16,-1
   rjmp strcmp_pm_ram_return
 strcmp_pm_ram_more:
   LDI r16,1
   rjmp strcmp_pm_ram_return
 strcmp_pm_ram_equal:
   LDI r16,0
   rjmp strcmp_pm_ram_return
   
 strcmp_pm_ram_return:  
   pop zh
   pop zl
   pop yh
   pop yl
   pop r18
   pop r17
  ret